#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>


void wait();

void blink();
void blinkred();
void blinkgreen();

	 
void main()
{
	PORTD = 0xff;
	DDRB = 0xff;
	blink();
	
	// alle interrupte an
	UCR = _BV(RXCIE) | _BV(RXEN);
	UBRR = 12;
	sei();
	while(1)
	{
		asm volatile("nop");
	}
}

SIGNAL(__vector_default)
{
	asm volatile("nop");
	return;
}

SIGNAL(SIG_UART_RECV)
{
	unsigned int i;
	
	i = UDR;
	if(i == 0x01)
	{
	    blinkred();
	    return;
	}
	if(i == 0x02)
	{
	    blinkgreen();
	    return;
	}
	return;
}


void blinkgreen()
{
	unsigned int i;
	for(i=0;i<5;i++)
	{
        PORTB = 0x01;
		wait();
		PORTB = 0x00;
		wait();
	}
}

void blinkred()
{
	unsigned int i;
	for(i=0;i<5;i++)
	{
        PORTB = 0x02;
		wait();
		PORTB = 0x00;
		wait();
	}
}


void blink()
{
	unsigned int i;
	for(i=0;i<5;i++)
	{
        PORTB = 0x01;
		wait();
		PORTB = 0x02;
		wait();
	}
	PORTB = 0x00;
}

void wait()
{
   	unsigned char i,j;
   	for(i=0;i<255;i++)
   	{
		for(j=0;j<255;j++)
		{
 			 asm volatile("nop");
 			 asm volatile("nop");
 			 asm volatile("nop");
		}
	}
}
